
public boolean toggleRead = false,
        toggleMSP_Data = true,
        toggleReset = false,
        toggleCalibAcc = false,
        toggleCalibMag = false,
        toggleWrite = false,
        toggleSpekBind = false,
        toggleSetSetting = false;
Serial g_serial;      // The serial port
float LastPort = 0;
int time,time1,time2,time3,time4,time5;

boolean ClosePort = false;
boolean PortIsWriting = false;
boolean FontMode = false;
int FontCounter = 0;
//int cindex = 0;
int CloseMode = 0;

/******************************* Multiwii Serial Protocol **********************/
//String boxnames[] = { // names for dynamic generation of config GUI
    //"ANGLE;",
    //"HORIZON;",
    //"BARO;",
    //"MAG;",
    //"ARM;",
    //"LLIGHTS;",
    //"GPS HOME;",
   // "GPS HOLD;",
   // "OSD SW;",
    
  //};


String boxnames[] = { // names for dynamic generation of config GUI
    "ARM;",
    "ANGLE;",
    "HORIZON;",
    "BARO;",
    "MAG;",
    "CAMSTAB;",
    "GPS HOME;",
    "GPS HOLD;",
//    "MISSION;",
    "AIR MODE;",
    "OSD SW;"   
  };
String strBoxNames = join(boxnames,""); 
//int modebits = 0;

private static final String MSP_HEADER = "$M<";

private static final int
  MSP_IDENT                =100,
  MSP_STATUS               =101,
  MSP_RAW_IMU              =102,
  MSP_SERVO                =103,
  MSP_MOTOR                =104,
  MSP_RC                   =105,
  MSP_RAW_GPS              =106,
  MSP_COMP_GPS             =107,
  MSP_ATTITUDE             =108,
  MSP_ALTITUDE             =109,
  MSP_ANALOG               =110,
  MSP_RC_TUNING            =111,
  MSP_PID                  =112,
  MSP_BOX                  =113,
  MSP_MISC                 =114,
  MSP_MOTOR_PINS           =115,
  MSP_BOXNAMES             =116,
  MSP_PIDNAMES             =117,
  MSP_BOXIDS               =119,
  MSP_RSSI                 =120,
  MSP_NAV_STATUS           =121,
  MSP_CELLS                =130,
  MSP_SET_RAW_RC           =200,
  MSP_SET_RAW_GPS          =201,
  MSP_SET_PID              =202,
  MSP_SET_BOX              =203,
  MSP_SET_RC_TUNING        =204,
  MSP_ACC_CALIBRATION      =205,
  MSP_MAG_CALIBRATION      =206,
  MSP_SET_MISC             =207,
  MSP_RESET_CONF           =208,
  MSP_SELECT_SETTING       =210,
  MSP_SPEK_BIND            =240,

  MSP_PASSTHRU_SERIAL      =244,

  MSP_EEPROM_WRITE         =250,
  
  MSP_DEBUGMSG             =253,
  MSP_DEBUG                =254;

private static final int
  MSP_OSD                  =220;

// Subcommands
private static final int
  OSD_NULL                 =0,
  OSD_READ_CMD             =1,
  OSD_WRITE_CMD            =2,
  OSD_GET_FONT             =3,
  OSD_SERIAL_SPEED         =4,
  OSD_RESET                =5,
  OSD_DEFAULT              =6,
  OSD_SENSORS              =7,
  OSD_WRITE_CMD_EE         =8,
  OSD_READ_CMD_EE          =9,
  OSD_INFO                 =10;



// initialize the serial port selected in the listBox
void InitSerial(float portValue) {
  if (portValue < commListMax) {
    if(init_com == 0){ 
      try{
      if (StartupMessage ==0){
        StartupMessage=1;
        updateConfig();
      }
      if (DonateMessage>0){
        DonateMessage=0;
      }

      String portPos = Serial.list()[int(portValue)];
      txtlblWhichcom.setValue("COM = " + shortifyPortName(portPos, 8));
      g_serial = new Serial(this, portPos, BaudRate);
      LastPort = portValue;
      init_com=1;
      //_Data = true;
      ClosePort = false;
      buttonREAD.setColorBackground(green_);
      buttonWRITE.setColorBackground(green_);
      buttonRESET.setColorBackground(green_);
      commListbox.setColorBackground(green_);
      buttonRESTART.setColorBackground(green_);

      ResetControl=int(SimControlToggle.getValue());
      ResetDispaly=int(SimDisplayToggle.getValue());
      Restart=1;

      g_serial.buffer(200);
            txtmessage.setText("");
//      delay(1500);
//      SendCommand(MSP_IDENT);
     

//      SendCommand(MSP_STATUS);
       eeaddressGUI=0;   
       ReadConfigMSPMillis=20000+millis();  
       READconfigMSP_init();
       } catch (Exception e) { // null pointer or serial port dead
         noLoop();
        JOptionPane.showConfirmDialog(null,"Error Opening Port It may be in Use", "Port Error", JOptionPane.PLAIN_MESSAGE,JOptionPane.WARNING_MESSAGE);
        loop();
        System.out.println("OpenPort error " + e);
     }
      //+((int)(cmd&0xFF))+": "+(checksum&0xFF)+" expected, got "+(int)(c&0xFF));
    }
  }
  else if((portValue > commListMax) && (init_com == 1)){
    if (Passthroughcomm==1) {
      System.out.println("Serial Port Pass Through Starting" );
      SendCommand(MSP_PASSTHRU_SERIAL);
      delay(1000);
//      SendCommand(MSP_IDENT);
//      SendCommand(MSP_STATUS);
      READconfigMSP_init();
    }
  }
  else {
    if(init_com == 1){
//     System.out.println("Begin Port Down " ); 
      txtlblWhichcom.setValue("Comm Closed");
      //g_serial.clear();
//      toggleMSP_Data = false;
      ClosePort = true;
      init_com=0;
    }
  }
  SimControlToggle.setValue(0);
}

void ClosePort(){
  init_com=0;
  g_serial.clear();
  g_serial.stop();
  
  //System.out.println("Port Turned Off " );
  init_com=0;
  commListbox.setColorBackground(red_);
  buttonREAD.setColorBackground(osdcontr_);
  buttonRESET.setColorBackground(osdcontr_);
  buttonWRITE.setColorBackground(osdcontr_);
  buttonRESTART.setColorBackground(osdcontr_);
  if (CloseMode > 0){
    InitSerial(LastPort);
    CloseMode = 0;
  }
    
  
}




void SetConfigItem(int index, int value) {
  if(index >= CONFIGITEMS)
    return;

  if(index == GetSetting("S_VOLTAGEMIN"))confItem[index].setValue(float(value)/10);//preserve decimal
  else if(index == GetSetting("S_VIDVOLTAGEMIN"))confItem[index].setValue(float(value)/10);//preserve decimal
  else if(index == GetSetting("S_GPSTZ"))confItem[index].setValue(float(value)/10);//preserve decimal, maybe can go elsewhere - haydent
  else confItem[index].setValue(value);
//  if (index == CONFIGITEMS-1)
//    buttonWRITE.setColorBackground(green_);
    
  if (value >0){
    toggleConfItem[index].setValue(1);
  }
  else{
    toggleConfItem[index].setValue(0);
  }

  try{
    switch(value) {
    case(0):
      RadioButtonConfItem[index].activate(0);
      break;
    case(1):
      RadioButtonConfItem[index].activate(1);
      break;
    }
  }
  catch(Exception e) {
  }finally {
  }
BuildCallSign();  	
}

void PORTCLOSE(){
//  toggleMSP_Data = false;
  CloseMode = 0;
  InitSerial(200.00);
}

void BounceSerial(){
//  toggleMSP_Data = false;
  CloseMode = 1;
  InitSerial(200.00);
  
}  

void RESTART(){
//  toggleMSP_Data = true;
  for (int txTimes = 0; txTimes<3; txTimes++) {
    headSerialReply(MSP_OSD, 1);
    serialize8(OSD_RESET);
    tailSerialReply();
    delay(100);
  }
//  toggleMSP_Data = false;
  READconfigMSP_init();
}  






public void FONT_UPLOAD(){
  if (init_com==0){
    noLoop();
    JOptionPane.showConfirmDialog(null,"Please Select a Port", "Not Connected", JOptionPane.PLAIN_MESSAGE,JOptionPane.WARNING_MESSAGE);
    loop();
  }else
  {
  FontMSPMillis=3000 + millis();
  SimControlToggle.setValue(0);
//  System.out.println("FONT_UPLOAD");
  //toggleMSP_Data = true;
  FontMode = true;
  PortWrite = true;
  MakePorts();
  FontCounter = 0;
  txtmessage.setText("  Please Wait");
  p = 0;
  inBuf[0] = OSD_GET_FONT;
  //for (int txTimes = 0; txTimes<2; txTimes++) {
    headSerialReply(MSP_OSD, 5);
    serialize8(OSD_GET_FONT);
    serialize16(7456);  // safety code
    serialize8(0);    // first char
    serialize8(255);  // last char
    tailSerialReply();
 //}
  }

}

public void SendChar(){
    FontMSPMillis=3000 + millis();
    time2=time;
    PortWrite = !PortWrite;  // toggle PortWrite to flash TX
    if (PortWrite) 
      txtmessage.setText("Upload: "+nf(FontCounter, 3)+"/256");
    else
      txtmessage.setText("");
    MakePorts();
//    System.out.println("Sent Char "+FontCounter);
    buttonSendFile.getCaptionLabel().setText("  " +nf(FontCounter, 3)+"/256");
    headSerialReply(MSP_OSD, 56);
    serialize8(OSD_GET_FONT);
    for(int i = 0; i < 54; i++){
      serialize8(int(raw_font[FontCounter][i]));
    }
    serialize8(FontCounter);
    tailSerialReply();
    if (FontCounter <255){
      FontCounter++;
    }else{ 
      g_serial.clear();
      PortWrite = false;
      FontMode = false;      
//      System.out.println("Finished Uploading Font");
      buttonSendFile.getCaptionLabel().setText("  Upload");
      txtmessage.setText("");
      READconfigMSP_init();
//      READinit();
      RESTART();
    } 
  
}


public void DEFAULT(){
 if (init_com==1){
//    toggleConfItem[0].setValue(0);
    noLoop();
    int Reset_result = JOptionPane.showConfirmDialog(this,"Are you sure you wish to set OSD to DEFAULT values?", "RESET OSD MEMORY",JOptionPane.WARNING_MESSAGE,JOptionPane.YES_NO_CANCEL_OPTION);
    loop();
    switch (Reset_result) {
      case JOptionPane.YES_OPTION:
        for (int txTimes = 0; txTimes<1; txTimes++) {
          headSerialReply(MSP_OSD, 1);
          serialize8(OSD_DEFAULT);
          tailSerialReply();
          delay(100);
        }
        delay(1000);     
        READconfigMSP_init();
        return;
      case JOptionPane.CANCEL_OPTION:
//        SimControlToggle.setValue(1);
        return;
      default:
//        SimControlToggle.setValue(1);
        return;
    }
 }else
 {
   noLoop();
   JOptionPane.showConfirmDialog(null,"Please Select a Port", "Not Connected", JOptionPane.PLAIN_MESSAGE,JOptionPane.WARNING_MESSAGE);
   loop();
 }

}




void SendCommand(int cmd){
  //int icmd = (int)(cmd&0xFF);
  switch(cmd) {
  
  case MSP_STATUS:
        PortIsWriting = true;
        Send_timer+=1;
        headSerialReply(MSP_STATUS, 11);
        serialize16(Send_timer);
        serialize16(0);
        serialize16(1|1<<1|1<<2|1<<3|0<<4);
        int modebits = 0;
        int BitCounter = 1;
        if(toggleModeItems[0].getValue()> 0) modebits |=1<<0;
        if(toggleModeItems[1].getValue()> 0) modebits |=1<<1;
        if(toggleModeItems[2].getValue()> 0) modebits |=1<<2;
        if(toggleModeItems[3].getValue()> 0) modebits |=1<<3;
        if(toggleModeItems[4].getValue()> 0) modebits |=1<<5;
        if(toggleModeItems[6].getValue()> 0) modebits |=1<<10;
        if(toggleModeItems[7].getValue()> 0) modebits |=1<<11;
        if(toggleModeItems[8].getValue()> 0) modebits |=1<<28;
        if(toggleModeItems[9].getValue()> 0) modebits |=1<<19;

        if(toggleModeItems[5].getValue()> 0) modebits |=1<<8;  //Send CAMSTAB
//        if(toggleModeItems[5].getValue()> 0) modebits |=1<<16; //Also send LLIGHTS      when CAMSTAB enabled - for testing
//        if(toggleModeItems[5].getValue()> 0) modebits |=1<<12; //Also send PASS         when CAMSTAB enabled - for testing
//        if(toggleModeItems[5].getValue()> 0) modebits |=1<<20; //Also send MISSION MODE when CAMSTAB enabled - for testing
//        if(toggleModeItems[5].getValue()> 0) modebits |=1<<29; //Also send ACROPLUS MODE when CAMSTAB enabled - for testing
        serialize32(modebits);
        serialize8(0);   // current setting
        tailSerialReply();
        PortIsWriting = false;
      break;
      
      case MSP_RC:
        PortIsWriting = true;
        headSerialReply(MSP_RC, 16);
        serialize16(int(Pitch_Roll.arrayValue()[0]));
        serialize16(int(Pitch_Roll.arrayValue()[1]));
        serialize16(int(Throttle_Yaw.arrayValue()[0]));
        serialize16(int(Throttle_Yaw.arrayValue()[1]));
        for (int i=5; i<=8; i++) {
          serialize16(1500);
        }
        tailSerialReply();
        PortIsWriting = false;
      break;
      
      case MSP_IDENT:
        PortIsWriting = true;
        headSerialReply(MSP_IDENT, 7);
        serialize8(101);   // multiwii version
        serialize8(0); // type of multicopter
        serialize8(0);         // MultiWii Serial Protocol Version
        serialize32(0);        // "capability"
        tailSerialReply();
        PortIsWriting = false;
      break;
 
      case MSP_PASSTHRU_SERIAL:
        PortIsWriting = true;
        serialize8('$');
        serialize8('M');
        serialize8('<');//this is the important bit
        outChecksum = 0; // start calculating a new checksum
        serialize8(1);
        serialize8(MSP_PASSTHRU_SERIAL);
        serialize8(0);
        tailSerialReply();
        PortIsWriting = false;
      break;

      case MSP_CELLS:
        PortIsWriting = true;
        headSerialReply(MSP_CELLS, 12);
        if (SFRSKY.arrayValue()[0]<1) break;
       if (int(confItem[GetSetting("S_BATCELLS")].value()) <1) break;
        int cellvolt= (int(sVBat * 100))/int(confItem[GetSetting("S_BATCELLS")].value());
        for (int i=0; i<6; i++) {
          if (i < int(confItem[GetSetting("S_BATCELLS")].value())) {
            serialize16(cellvolt);
          }
          else {
            serialize16(0);
          }
        }
        tailSerialReply();
        PortIsWriting = false;
      break;


      case MSP_BOXNAMES:
        PortIsWriting = true;
        headSerialReply(MSP_BOXNAMES,strBoxNames.length());
        serializeNames(strBoxNames.length());
        tailSerialReply();
        PortIsWriting = false;
      break;
      
      case MSP_BOXIDS:
        PortIsWriting = true;
        headSerialReply(MSP_BOXIDS,30);
        for (int i=0; i<30; i++) {
        serialize8(i);
        }
        tailSerialReply();
        PortIsWriting = false;
    break;

     
      case MSP_ATTITUDE:
                PortIsWriting = true;
        headSerialReply(MSP_ATTITUDE, 8);
        serialize16(int(MW_Pitch_Roll.arrayValue()[0])*10);
        serialize16(int(MW_Pitch_Roll.arrayValue()[1])*10);
        serialize16(MwHeading);
        serialize16(0);
        tailSerialReply();
        PortIsWriting = false;
      break;
     


      case MSP_DEBUG:
        PortIsWriting = true;
        headSerialReply(MSP_DEBUG, 8);

        //for (int i = 0; i < 4; i++) {
        //  debug[i]++;
        //}

        serialize16(debug[0]);
        serialize16(debug[1]);
        serialize16(debug[2]);
        serialize16(debug[3]);
        tailSerialReply();
        PortIsWriting = false;
      break;
     
     
      case MSP_PID:
        int PIDITEMS = 10;
        PortIsWriting = true;
        headSerialReply(MSP_PID, 10*3);
        for(int i=0; i<PIDITEMS; i++) {
          for(int ii=0; ii<3; ii++) {
           int pidval=int(i*10)+ii;
            serialize8(pidval);
          }
        }

        tailSerialReply();
        PortIsWriting = false;
      break;

      case MSP_ANALOG:
        PortIsWriting = true;
        headSerialReply(MSP_ANALOG, 7);
        serialize8(int(sVBat * 10));
        serialize16(0);
        serialize16(int(sMRSSI));
        serialize16(int(map(Throttle_Yaw.arrayValue()[1],1000,2000,0,50000)));
        tailSerialReply();
        PortIsWriting = false;
      break;
      

      case MSP_NAV_STATUS:
        PortIsWriting = true;
        headSerialReply(MSP_NAV_STATUS, 7);
        if (millis()>oldwpmillis+1500){
          oldwpmillis=millis();
          wpno++;
          if (wpno>15) wpno=0;
        }
        serialize8(0);
        serialize8(0);
        serialize8(0);
        serialize8(wpno);
        serialize8(0);
        serialize8(0);
        serialize8(0);
        tailSerialReply();
        PortIsWriting = false;
      break;
 
     
      case MSP_RAW_GPS:
        // We have: GPS_fix(0-2), GPS_numSat(0-15), GPS_coord[LAT & LON](signed, in 1/10 000 000 degres), GPS_altitude(signed, in meters) and GPS_speed(in cm/s)  
        headSerialReply(MSP_RAW_GPS,16);
        serialize8(int(SGPS_FIX.arrayValue()[0]));
        serialize8(int(SGPS_numSat.value()));
        GPSstartlat=GPSstartlat+100;
        GPSstartlon=GPSstartlon+100;
        serialize32(GPSstartlat);
        serialize32(GPSstartlon);
        serialize16(int(SGPS_altitude.value()/100));
        serialize16(int(SGPS_speed.value()));
        serialize16(MwHeading*10);     
    break;
    
  
    case MSP_COMP_GPS:
      if(confItem[GetSetting("S_GPSTIME")].value()>0)
        headSerialReply(MSP_COMP_GPS,9);
      else
        headSerialReply(MSP_COMP_GPS,5);
      serialize16(int(SGPS_distanceToHome.value()));
      int GPSheading = int(SGPSHeadHome.value());
      if(GPSheading < 0) GPSheading += 360;
      serialize16(GPSheading);
      serialize8(0);
      if(confItem[GetSetting("S_GPSTIME")].value()>0) {
        int osdtime=hour()*3600+minute()*60+second();
        osdtime = osdtime*1000;
        serialize32(osdtime);
      }
    break;
    
    
    case MSP_ALTITUDE:
      headSerialReply(MSP_ALTITUDE, 6);
      serialize32(int(sAltitude) *100);
      serialize16(int(sVario) *10);     
    break;
      
    }
    tailSerialReply();   
  
}

// coded by Eberhard Rensch
// Truncates a long port name for better (readable) display in the GUI
String shortifyPortName(String portName, int maxlen)  {
  String shortName = portName;
  if(shortName.startsWith("/dev/")) shortName = shortName.substring(5);  
  if(shortName.startsWith("tty.")) shortName = shortName.substring(4); // get rid of leading tty. part of device name
  if(portName.length()>maxlen) shortName = shortName.substring(0,(maxlen-1)/2) + "~" +shortName.substring(shortName.length()-(maxlen-(maxlen-1)/2));
  if(shortName.startsWith("cu.")) shortName = "";// only collect the corresponding tty. devices
  return shortName;
}

public static final int
  IDLE = 0,
  HEADER_START = 1,
  HEADER_M = 2,
  HEADER_ARROW = 3,
  HEADER_SIZE = 4,
  HEADER_CMD = 5,
  HEADER_ERR = 6;

private static final String MSP_SIM_HEADER = "$M>";
int c_state = IDLE;
boolean err_rcvd = false;
byte checksum=0;
byte cmd = 0;
int offset=0, dataSize=0;
byte[] inBuf = new byte[256];
int Send_timer = 1;
int p=0;
int read32() {return (inBuf[p++]&0xff) + ((inBuf[p++]&0xff)<<8) + ((inBuf[p++]&0xff)<<16) + ((inBuf[p++]&0xff)<<24); }
int read16() {return (inBuf[p++]&0xff) + ((inBuf[p++])<<8); }
int read8()  {return inBuf[p++]&0xff;}



int outChecksum;


void serialize8(int val) {
 if (init_com==1)  {
     //if(str(val)!=null){
       try{
       g_serial.write(val);
       outChecksum ^= val;
       } catch(java.lang.Throwable t) {
         System.out.println( t.getClass().getName() ); //this'll tell you what class has been thrown
         t.printStackTrace(); //get a stack trace
       }
     //}
 }

}

void serialize16(int a) {
  if (str(a)!=null ){
  serialize8((a   ) & 0xFF);
  serialize8((a>>8) & 0xFF);
  }
}

void serialize32(int a) {
  if (str(a)!=null ){
    serialize8((a    ) & 0xFF);
    serialize8((a>> 8) & 0xFF);
    serialize8((a>>16) & 0xFF);
    serialize8((a>>24) & 0xFF);
  }
 
}

void serializeNames(int s) {
  //for (PGM_P c = s; pgm_read_byte(c); c++) {
   // serialize8(pgm_read_byte(c));
  //}
  for (int c = 0; c < strBoxNames.length(); c++) {
    serialize8(strBoxNames.charAt(c));
  }
}

void headSerialResponse(int requestMSP, Boolean err, int s) {
  //if (FontMode)DelayTimer(1);
  serialize8('$');
  serialize8('M');
  serialize8(err ? '!' : '>');
  outChecksum = 0; // start calculating a new checksum
  serialize8(s);
  serialize8(requestMSP);
}

void headSerialReply(int requestMSP, int s) {
  if ((str(requestMSP) !=null) && (str(s)!=null)){
    headSerialResponse(requestMSP, false, s);
  }
}

//void headSerialError(int requestMSP, int s) {
// headSerialResponse(requestMSP, true, s);
//}

void tailSerialReply() {
  serialize8(outChecksum);
}

public void DelayTimer(int ms){
  int time = millis();
  while(millis()-time < ms);
}

public void evaluateCommand(byte cmd, int size) {
  if ((init_com==0)){
    return;
  }

  PortRead = true;
  MakePorts(); 
  int icmd = int(cmd&0xFF);
  if (int(DEBUGGUI.getValue())==1){
    msptxt="MSP: "+icmd;   
    mspmessage.setValue(msptxt);
  }
//  if (icmd !=MSP_OSD)return;  //System.out.println("Not Valid Command");
  time2=time;

  switch(icmd) {

    case MSP_RC:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_RC);
      break;
    case MSP_STATUS:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_STATUS);
      break;
    case MSP_BOXNAMES:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_BOXNAMES);
      break;
    case MSP_BOXIDS:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_BOXIDS);
      break;
    case MSP_IDENT:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_IDENT);
      break;
    case MSP_ANALOG:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_ANALOG);
      break;
    case MSP_COMP_GPS:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_COMP_GPS);
      break;
    case MSP_RAW_GPS:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_RAW_GPS);
      break;
    case MSP_ATTITUDE:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_ATTITUDE);
      break;
    case MSP_ALTITUDE:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_ALTITUDE);
      break;
    case MSP_CELLS:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_CELLS);
      break;
    case MSP_NAV_STATUS:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_NAV_STATUS);
      break;
    case MSP_DEBUG:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_DEBUG);
      break;
    case MSP_PID:
      if ((int(SimControlToggle.getValue())!=0)&&(Simtype==1)) SendCommand(MSP_PID);
      break; 
   
    case MSP_OSD:
      int cmd_internal = read8();
      PortRead = true;
      MakePorts();
//      msptxt="MSP: "+cmd_internal;   


      if(cmd_internal == OSD_NULL) {
      }
      if(cmd_internal == OSD_INFO) { // response to a sensor request - info
        if (int(DEBUGGUI.getValue())==1){
         int infoL;
         int infoH;
         int info16;
         String  info16text;
         infomessage.setValue("OSD info:");
         for (int i=0; i<infoSENSORS; i++) {
           infoL=read8();
           infoH=read8();
           info16=infoL+(infoH<<8);
           info16text="Unknown";
           switch(i) {
             case 0:
               switch(info16) {
                 case 0:
                   info16text="Unknown";
                   break;
                 case 1:
                   info16text="Multiwii";
                   break;
                 case 2:
                   info16text="Baseflight";
                   break;
                 case 3:
                   info16text="Librepilot";
                   break;
                 case 4:
                   info16text="Taulabs";
                   break;
                 case 5:
                   info16text="Dronin";
                   break;
                 case 6:
                   info16text="Cleanflight";
                   break;
                 case 7:
                   info16text="Betaflight";
                   break;
                 case 8:
                   info16text="PatrikE FW";
                   break;
                 case 9:
                   info16text="PatrikE FW";
                   break;
                 case 10:
                   info16text="Harakiri";
                   break;
                 case 11:
                   info16text="Naza";
                   break;
                 case 12:
                   info16text="iNAV";
                   break;
                 case 13:
                   info16text="Kiss";
                   break;
                 case 14:
                   info16text="APM";
                   break;
                 case 15:
                   info16text="Pixhawk";
                   break;
                 case 16:
                   info16text="Skytrack";
                   break;
                 case 17:
                   info16text="OSD (UBLOX)";
                   break;
                 case 18:
                   info16text="OSD (MTK)";
                   break;
                 case 19:
                   info16text="OSD (NMEA)";
                   break;
                 case 20:
                   info16text="OSD (Basic)";
                   break;
                 default: 
                   info16text="Unknown";
              } 
               txtlblinfo[i].setValue("Controller : "+info16text);
               break;
             case 1:
                switch(info16) {
                 case 0:
                   info16text="Unknown";
                   break;
                 case 1:
                   info16text="Minim";
                   break;
                 case 2:
                   info16text="MicroMinim";
                   break;
                 case 3:
                   info16text="Aeromax";
                   break;
                 case 4:
                   info16text="RTFQ v1";
                   break;
                 case 5:
                   info16text="RTFQ micro";
                   break;
                 case 6:
                   info16text="Rushduino";
                   break;
                 case 7:
                   info16text="Kylin 250";
                   break;
                 case 8:
                   info16text="Airbot Micro";
                   break;
                 default: 
                   info16text="Unknown";
              } 
              txtlblinfo[i].setValue("Hardware  : "+info16text);
               break;
             case 2:
               txtlblinfo[i].setValue("Version : "+info16);
               break;
             case 3:
                switch(info16) {
                 case 0:
                   info16text="Airplane";
                   break;
                 case 1:
                   info16text="MultiRotor";
                   break;
                 default: 
                   info16text="Unknown";
                 }
               txtlblinfo[i].setValue("Aircraft  : "+info16text);
               break;
             case 4:
               txtlblinfo[i].setValue("Options : "+info16);
               break;
             default:  
           }
         }
        }
        else {
          msptxt="";
          infomessage.setValue("");
          for (int i=0; i<infoSENSORS; i++) {
            txtlblinfo[i].setValue("");
          }
        }

      }      
      if(cmd_internal == OSD_SENSORS) { // response to a sensor request
        if (int(DEBUGGUI.getValue())==1){
         int analL;
         int analH;
         int analsense;
         analmessage.setValue("OSD sensors 0-1023:");
         for (int i=0; i<analSENSORS; i++) {
           analL=read8();
           analH=read8();
           analsense=analL+(analH<<8);
           switch(i) {
             case 0:
               txtlblanal[i].setValue("Volt 1 : "+analsense);
               break;
             case 1:
               txtlblanal[i].setValue("Volt 2 : "+analsense);
               break;
             case 2:
               txtlblanal[i].setValue("Amps  : "+analsense);
               break;
             case 3:
               txtlblanal[i].setValue("Temp  : "+analsense);
               break;
             case 4:
               rssical=analsense;
               txtlblanal[i].setValue("RSSI  : "+analsense);
               break;
             default:  
               txtlblanal[i].setValue("Sens "+i+" : "+analsense);
           }
         }
        }
        else {
          msptxt="";
          analmessage.setValue("");
          eeindextxt="";
          for (int i=0; i<analSENSORS; i++) {
            txtlblanal[i].setValue("");
          }
        }
      }


      if(cmd_internal == OSD_READ_CMD_EE) { // response to a read / write request
        if(size == 3) { // confirmed write request received
          int eeaddressOSDL=read8();
          int eeaddressOSDH=read8();
          eeaddressOSD=eeaddressOSDL+(eeaddressOSDH<<8);
          eeindextxt="EEW: "+eeaddressOSD;   
// System.out.println("OSD req:"+ eeaddressOSD);
          eeindexmessage.setValue(eeindextxt);

          if (eeaddressOSD>=eeaddressGUI){ // update base address
            eeaddressGUI=eeaddressOSD;
          }
          if (WriteLayouts==1){
            if (eeaddressGUI>=(CONFIGITEMS + CONFIGITEMS16 + 1+(hudoptions*2*3))){ // hit end address
              WriteConfigMSPMillis=0;
            }
          }              
          else{
            if (eeaddressGUI>=(CONFIGITEMS + CONFIGITEMS16+1)){ // hit end address
              WriteConfigMSPMillis=0;
            }
          }
        }
        else{ // confirmed read request received
         int eeaddressoffset = 0;
         int configcount8  = CONFIGITEMS-CONFIGITEMS16-1;
         int configcount16 = CONFIGITEMS16;
         int bit16=0;
         int lowbit=0;
         int highbit=0;
         int gbug=0;
         for(int i=0; i<10; i++) {
            eeaddressOSD=read8();
            eeaddressOSD=eeaddressOSD+read8();
            eeindextxt="EER: "+eeaddressOSD;   
            eeindexmessage.setValue(eeindextxt);

            eedataOSD=read8();
            if (eeaddressOSD==0){
              confCheck=eedataOSD;
            }
            if (eeaddressOSD==GetSetting("S_HUDSW0")){
              OSD_S_HUDSW0=eedataOSD;
            }
            if (eeaddressOSD==GetSetting("S_HUDSW1")){
              OSD_S_HUDSW1=eedataOSD;
            }
            if (eeaddressOSD==GetSetting("S_HUDSW2")){
              OSD_S_HUDSW2=eedataOSD;
            }
            if (eeaddressOSD<(configcount8)){
              SetConfigItem(eeaddressOSD, eedataOSD);
              bit16=0;
            }
            else if(eeaddressOSD==configcount8){
            }
            else if(eeaddressOSD<(configcount8+configcount16<<2)){
              bit16=1;
              eeaddressoffset = (eeaddressOSD-1-configcount8)/2;
              gbug=(eeaddressOSD-configcount8)%2;
              if(((eeaddressOSD+1-configcount8)%2)==0){ // low bit
               highbit=0;
               eedataOSDtemp = eedataOSD;
              }
              else{
               highbit=1;
               int eedataOSDtemph = eedataOSD<<8;
               eedataOSDtemp = eedataOSDtemp+eedataOSDtemph;
               SetConfigItem((configcount8+1+eeaddressoffset), eedataOSDtemp);
              }
            } 
//            System.out.println("A:"+ eeaddressOSD+" D:"+eedataOSD+" T:"+eedataOSDtemp+" O:"+eeaddressoffset+" 16:"+bit16+" HB:"+highbit+" GB:"+gbug);
            
//            if (eeaddressOSD==GetSetting("S_AMPMAXH")){ // 16 bit value amps manipulation now received all data
//              S16_AMPMAX=(int(confItem[GetSetting("S_AMPMAXH")].value())<<8)+ int(confItem[GetSetting("S_AMPMAXL")].value()); 
//              SetConfigItem(GetSetting("S_AMPDIVIDERRATIO"), (int) S16_AMPMAX);
//            }
            if (eeaddressOSD==eeaddressGUI){ // update base address
              eeaddressGUI++;
            }
          }
          if (eeaddressGUI>=(CONFIGITEMS+CONFIGITEMS16)){ // hit end address config only
            ReadConfigMSPMillis=0;
            SimControlToggle.setValue(ResetControl);
            SimDisplayToggle.setValue(ResetDispaly);
          }
        }
        if (MW_OSD_EEPROM_Version!=confCheck){
          noLoop();
          JOptionPane.showConfirmDialog(null,"GUI version does not match OSD version - use correct GUI version or update OSD.", "Version Mismatch Warning", JOptionPane.PLAIN_MESSAGE,JOptionPane.WARNING_MESSAGE);
          loop();   
          ReadConfigMSPMillis=0;
          WriteConfigMSPMillis=0;   
        }   
     debug[0]=1;
     debug[1]=int(confItem[GetSetting("S16_RSSIMAX")].value());
     debug[2]=int(confItem[GetSetting("S16_SPARE1")].value());
     debug[3]=eeaddressOSD;     
      }


        if(cmd_internal == OSD_GET_FONT) {
          if( size == 1) {
            //headSerialReply(MSP_OSD, 5);
            //serialize8(OSD_GET_FONT);
            //serialize16(7456);  // safety code
            //serialize8(0);    // first char
            //serialize8(255);  // last char
           // tailSerialReply();
          }
          if(size == 3) {
           
            //txtmessage.setText("  Please Wait");
           // PortRead = true;
            //PortWrite = true; 
            //int cindex = read16();
            //if((cindex&0xffff) == 0xffff) { // End!
              //FontCounter = 255;
             // headSerialReply(MSP_OSD, 1);
             // serialize8(OSD_NULL);
             // tailSerialReply();
             // toggleMSP_Data = false;
             // g_serial.clear();
             // PortRead = false;
             // PortWrite = false;
              //FontMode = false;      
             // System.out.println("End marker "+cindex);
             // buttonSendFile.getCaptionLabel().setText("  Upload");
             // txtmessage.setText("");
              //InitSerial(200.00);
             // RESTART();
             // g_serial.clear();
             // g_serial.stop();
             // g_serial = new Serial(this, Serial.list()[int(LastPort)], 115200);
             // READ();
              
            //}
            //else {
              //PortWrite = true;
              //MakePorts();
              //headSerialReply(MSP_OSD, 56);
              //serialize8(OSD_GET_FONT);
             // for(int i = 0; i < 54; i++){
                //serialize8(int(raw_font[cindex][i]));
              //}
              //serialize8(cindex);
              //tailSerialReply(); 
              
//     // XXX Fake errors to force retransmission
//        if(int(random(3)) == 0) {
//          System.out.println("Messed char "+cindex);
//          outChecksum ^= int(random(1,256));
//        }
//        else
//     // End fake errors code
          //System.out.println("Sent Char "+cindex);
          //buttonSendFile.getCaptionLabel().setText("  " +nf(cindex, 3)+"/256");
        //}
      }
    }
    break;
  }
}

void MWData_Com() {
  if ((init_com==0)) return;
//  if ((toggleMSP_Data == false) ||(init_com==0)) return;
  int i,aa;
  float val,inter,a,b,h;
  int c = 0;
  
  //System.out.println("MWData_Com");  
    int serialprocess=50; // max chars processed to help with PC's that processs serial slowly
    if (g_serial.available()==0){
      serialprocess=0;
    }
    while (serialprocess>0) {
      serialprocess--;
//    while (g_serial.available()>0 && (toggleMSP_Data == true)) {
    try{
      c = (g_serial.read());
      
     if (str(c) == null)return;
      
      PortRead = true;
      MakePorts();
      if (c_state == IDLE) {
        c_state = (c=='$') ? HEADER_START : IDLE;
      }
      else if (c_state == HEADER_START) {
        c_state = (c=='M') ? HEADER_M : IDLE;
      }
      else if (c_state == HEADER_M) {
        if (c == '<') {
          c_state = HEADER_ARROW;
        } else if (c == '!') {
          c_state = HEADER_ERR;
        } else {
          c_state = IDLE;
        }
      }
      else if (c_state == HEADER_ARROW || c_state == HEADER_ERR) {
        /* is this an error message? */
        err_rcvd = (c_state == HEADER_ERR);        /* now we are expecting the payload size */
        dataSize = (c&0xFF);
        /* reset index variables */
        p = 0;
        offset = 0;
        checksum = 0;
        checksum ^= (c&0xFF);
        /* the command is to follow */
        c_state = HEADER_SIZE;
      }
      else if (c_state == HEADER_SIZE) {
        cmd = (byte)(c&0xFF);
        checksum ^= (c&0xFF);
        c_state = HEADER_CMD;
      }
      else if (c_state == HEADER_CMD && offset < dataSize) {
          checksum ^= (c&0xFF);
          inBuf[offset++] = (byte)(c&0xFF);
      } 
      else if (c_state == HEADER_CMD && offset >= dataSize) {
        /* compare calculated and transferred checksum */
        if ((checksum&0xFF) == (c&0xFF)) {
          if (err_rcvd) {
            //System.err.println("Copter did not understand request type "+c);
          } else {
            /* we got a valid response packet, evaluate it */
            try{
              if ((init_com==1)) {
                  evaluateCommand(cmd, (int)dataSize);
//                  System.out.println("CMD: "+cmd);
                  PortRead = false;
              }
              else{
//                System.out.println("port is off ");
              }
              
              
              } catch (Exception e) { // null pointer or serial port dead
              System.out.println("write error " + e);
              }
           
          }
        }
        else {
          System.out.println("invalid checksum for command "+((int)(cmd&0xFF))+": "+(checksum&0xFF)+" expected, got "+(int)(c&0xFF));
          System.out.print("<"+(cmd&0xFF)+" "+(dataSize&0xFF)+"> {");
          for (i=0; i<dataSize; i++) {
            if (i!=0) { System.err.print(' '); }
            System.out.print((inBuf[i] & 0xFF));
          }
          System.out.println("} ["+c+"]");
          System.out.println(new String(inBuf, 0, dataSize));
        }
        c_state = IDLE;
        
      }
      
      } catch(java.lang.Throwable t) {
         System.out.println( t.getClass().getName() ); //this'll tell you what class has been thrown
         t.printStackTrace(); //get a stack trace
      }
    }
}

  public void READconfigMSP_init(){
//    println("Console test print");
    SimControlToggle.setValue(0);
    SimDisplayToggle.setValue(0);
    ReadConfigMSPMillis=1000+millis(); 
    WriteConfigMSPMillis=millis(); 
    eeaddressGUI=0;
  }

  public void READconfigMSP(){
//  toggleMSP_Data = true;
  inBuf[0] = OSD_WRITE_CMD;
  for (int txTimes = 0; txTimes<1; txTimes++) {
    headSerialReply(MSP_OSD, 4);
    serialize8(OSD_READ_CMD_EE);
    int tmpeeadd = eeaddressGUI&0xFF;
    serialize8(tmpeeadd);
    tmpeeadd = eeaddressGUI>>8;
    serialize8(tmpeeadd);
    serialize8(99);
    tailSerialReply();
//    SimControlToggle.setValue(1);    
    SendSim=1;
    ClosePort = false; 

  }
//  toggleMSP_Data = false; //???????????????????
  ReadConfigMSPMillis=1000+millis(); 
}

  public void get_OSD_SENSORS(){
    headSerialReply(MSP_OSD, 1);
    serialize8(OSD_SENSORS);
    tailSerialReply();
  }

  public void WRITEconfigMSP_init(){
    SimControlToggle.setValue(0);
    SimDisplayToggle.setValue(0);
    eeaddressGUI=0;  
    CheckCallSign(); 
    EElookuptableReSet();

    WriteLayouts=0;
    if (OSD_S_HUDSW0!=int(confItem[GetSetting("S_HUDSW0")].value())){
      OSD_S_HUDSW0=int(confItem[GetSetting("S_HUDSW0")].value());
      WriteLayouts=1;
    }
    if (OSD_S_HUDSW1!=int(confItem[GetSetting("S_HUDSW1")].value())){
      OSD_S_HUDSW1=int(confItem[GetSetting("S_HUDSW1")].value());
      WriteLayouts=1;
    }
    if (OSD_S_HUDSW2!=int(confItem[GetSetting("S_HUDSW2")].value())){
      OSD_S_HUDSW2=int(confItem[GetSetting("S_HUDSW2")].value());
      WriteLayouts=1;
    }

    EepromWriteSize = CONFIGITEMS+1;
    if (WriteLayouts==1){
      EepromWriteSize = CONFIGITEMS+1+(hudoptions*2*3);
    }

    WriteConfigMSPMillis=1000+millis(); 
  }

  public void WRITEconfigMSP(){
  SimControlToggle.setValue(0);
//  toggleMSP_Data = true;
  inBuf[0] = OSD_WRITE_CMD;
  for (int txTimes = 0; txTimes<1; txTimes++) {
    headSerialReply(MSP_OSD, 1 + (3*10));
    serialize8(OSD_WRITE_CMD_EE);
    for(int i=0; i<10; i++) {
      int tmpeeadd = (i+eeaddressGUI)&0xFF;
      serialize8(tmpeeadd);
      tmpeeadd = (i+eeaddressGUI)>>8;
      serialize8(tmpeeadd);
      serialize8(EElookuptable[i+eeaddressGUI]);
// System.out.println(eeaddressGUI+i+":"+EElookuptable[i+eeaddressGUI]);
    }
    tailSerialReply();
  }
//  toggleMSP_Data = false; //???????????????????
  WriteConfigMSPMillis=3000+millis(); 
}

  public void EElookuptableReSet(){ // preparing for a write
//    confItem[GetSetting("S_AMPMAXL")].setValue(int(confItem[GetSetting("S_AMPDIVIDERRATIO")].value())&0xFF); // for 8>>16 bit EEPROM
//    confItem[GetSetting("S_AMPMAXH")].setValue(int(confItem[GetSetting("S_AMPDIVIDERRATIO")].value())>>8);
    for(int i = 0; i < CONFIGITEMS; i++){
      if(i == GetSetting("S_VOLTAGEMIN")){
        EElookuptable[i]=int(confItem[i].value()*10);
      }
      else if(i == GetSetting("S_VIDVOLTAGEMIN")){
        EElookuptable[i]=int(confItem[i].value()*10);
      }
      else if(i == GetSetting("S_GPSTZ")){
        EElookuptable[i]=int(confItem[i].value()*10);
      }
      else{
        EElookuptable[i]=int(confItem[i].value());
      }

    }

      int EElookuptableaddress=CONFIGITEMS-CONFIGITEMS16;
      for(int i = 0; i < CONFIGITEMS16; i++){
        int ii=(CONFIGITEMS-CONFIGITEMS16)+(i);
        int gtmp=int(confItem[ii].value())&0xFF;
        EElookuptable[EElookuptableaddress]=int(confItem[ii].value())&0xFF;
//        System.out.println("A:"+ EElookuptableaddress+" D:"+gtmp);
        EElookuptableaddress++;
        gtmp=int(confItem[ii].value())>>8;
        EElookuptable[EElookuptableaddress]=int(confItem[ii].value())>>8;
//        System.out.println("A:"+ EElookuptableaddress+" D:"+gtmp);
        EElookuptableaddress++;
      }


     EElookuptableaddress=CONFIGITEMS+CONFIGITEMS16;
     for(int i = 0; i < (hudoptions); i++){
       EElookuptable[EElookuptableaddress]=int(ConfigLayout[0][i]&0xFF);
       EElookuptableaddress++;
       EElookuptable[EElookuptableaddress]=int(ConfigLayout[0][i]>>8);
       EElookuptableaddress++;
     }
     for(int i = 0; i < (hudoptions); i++){
       EElookuptable[EElookuptableaddress]=int(ConfigLayout[1][i]&0xFF);
       EElookuptableaddress++;
       EElookuptable[EElookuptableaddress]=int(ConfigLayout[1][i]>>8);
       EElookuptableaddress++;
     }
     for(int i = 0; i < (hudoptions); i++){
       EElookuptable[EElookuptableaddress]=int(ConfigLayout[2][i]&0xFF);
       EElookuptableaddress++;
       EElookuptable[EElookuptableaddress]=int(ConfigLayout[2][i]>>8);
       EElookuptableaddress++;
     }
  }
  
  
//  public void OSD2EElookuptable(){ // Sync settings with EE table
//  }

  public void EElookuptable2GUIsettings(){ // Sync settings from EE table to GUI
  }

